From fd65582aa669d5950d53b6c2da0c537a02f2db7d Mon Sep 17 00:00:00 2001
From: Shazad Hussain <quic_shazhuss@quicinc.com>
Date: Mon, 12 Dec 2022 14:47:41 +0530
Subject: [PATCH] hack: clk: qcom: enable gcc video clks and set mvs0 video clk
 frequency

Keep cv/video gcc clocks to be always on for venus f/w requirements.

Set required frequency of 560MHz to video_cc_mvs0_clk.
Set mvs1 and mvs1c clocks frequency to 600MHz.

Signed-off-by: Shazad Hussain <quic_shazhuss@quicinc.com>
---
 drivers/clk/qcom/gcc-lemans.c     | 9 +++++++--
 drivers/clk/qcom/videocc-lemans.c | 9 ++++++++-
 2 files changed, 15 insertions(+), 3 deletions(-)

diff --git a/drivers/clk/qcom/gcc-lemans.c b/drivers/clk/qcom/gcc-lemans.c
index 0bb0ef955202..a6e2fe0975d9 100644
--- a/drivers/clk/qcom/gcc-lemans.c
+++ b/drivers/clk/qcom/gcc-lemans.c
@@ -2864,6 +2864,7 @@ static struct clk_branch gcc_qmip_video_cvp_ahb_clk = {
 		.enable_mask = BIT(0),
 		.hw.init = &(const struct clk_init_data){
 			.name = "gcc_qmip_video_cvp_ahb_clk",
+			.flags = CLK_IS_CRITICAL,
 			.ops = &clk_branch2_ops,
 		},
 	},
@@ -2879,6 +2880,7 @@ static struct clk_branch gcc_qmip_video_vcodec_ahb_clk = {
 		.enable_mask = BIT(0),
 		.hw.init = &(const struct clk_init_data){
 			.name = "gcc_qmip_video_vcodec_ahb_clk",
+			.flags = CLK_IS_CRITICAL,
 			.ops = &clk_branch2_ops,
 		},
 	},
@@ -2894,6 +2896,7 @@ static struct clk_branch gcc_qmip_video_vcpu_ahb_clk = {
 		.enable_mask = BIT(0),
 		.hw.init = &(const struct clk_init_data){
 			.name = "gcc_qmip_video_vcpu_ahb_clk",
+			.flags = CLK_IS_CRITICAL,
 			.ops = &clk_branch2_ops,
 		},
 	},
@@ -4295,7 +4298,7 @@ static struct clk_branch gcc_usb_clkref_en = {
 
 static struct clk_branch gcc_video_axi0_clk = {
 	.halt_reg = 0x34014,
-	.halt_check = BRANCH_HALT_VOTED,
+	.halt_check = BRANCH_HALT_SKIP,
 	.hwcg_reg = 0x34014,
 	.hwcg_bit = 1,
 	.clkr = {
@@ -4303,6 +4306,7 @@ static struct clk_branch gcc_video_axi0_clk = {
 		.enable_mask = BIT(0),
 		.hw.init = &(const struct clk_init_data){
 			.name = "gcc_video_axi0_clk",
+			.flags = CLK_IS_CRITICAL,
 			.ops = &clk_branch2_ops,
 		},
 	},
@@ -4310,7 +4314,7 @@ static struct clk_branch gcc_video_axi0_clk = {
 
 static struct clk_branch gcc_video_axi1_clk = {
 	.halt_reg = 0x3401c,
-	.halt_check = BRANCH_HALT_VOTED,
+	.halt_check = BRANCH_HALT_SKIP,
 	.hwcg_reg = 0x3401c,
 	.hwcg_bit = 1,
 	.clkr = {
@@ -4318,6 +4322,7 @@ static struct clk_branch gcc_video_axi1_clk = {
 		.enable_mask = BIT(0),
 		.hw.init = &(const struct clk_init_data){
 			.name = "gcc_video_axi1_clk",
+			.flags = CLK_IS_CRITICAL,
 			.ops = &clk_branch2_ops,
 		},
 	},
diff --git a/drivers/clk/qcom/videocc-lemans.c b/drivers/clk/qcom/videocc-lemans.c
index 2e658c0a5e66..71197d5d5ae6 100644
--- a/drivers/clk/qcom/videocc-lemans.c
+++ b/drivers/clk/qcom/videocc-lemans.c
@@ -484,6 +484,7 @@ MODULE_DEVICE_TABLE(of, video_cc_lemans_match_table);
 static int video_cc_lemans_probe(struct platform_device *pdev)
 {
 	struct regmap *regmap;
+	int ret;
 
 	regmap = qcom_cc_map(pdev, &video_cc_lemans_desc);
 	if (IS_ERR(regmap))
@@ -500,7 +501,13 @@ static int video_cc_lemans_probe(struct platform_device *pdev)
 	regmap_update_bits(regmap, 0x80ec, BIT(0), BIT(0));
 	regmap_update_bits(regmap, 0x8128, BIT(0), BIT(0));
 
-	return qcom_cc_really_probe(pdev, &video_cc_lemans_desc, regmap);
+	//return qcom_cc_really_probe(pdev, &video_cc_lemans_desc, regmap);
+	ret = qcom_cc_really_probe(pdev, &video_cc_lemans_desc, regmap);
+	clk_set_rate(video_cc_mvs0_clk.clkr.hw.clk, 560000000);
+	clk_set_rate(video_cc_mvs1c_clk.clkr.hw.clk, 600000000);
+	clk_set_rate(video_cc_mvs1_clk.clkr.hw.clk, 600000000);
+
+	return ret;
 }
 
 static struct platform_driver video_cc_lemans_driver = {
-- 
2.38.0

